## jsoncons 1.3.1

=== debian/changelog ===
jsoncons (1.3.1-1) unstable; urgency=medium

  * d/tests: disable autopkgtest on riscv64 since being too slow.
  * New upstream version 1.3.1.
  * d/patches: refresh existing patches.

 -- Shengqi Chen <harry@debian.org>  Sun, 13 Apr 2025 15:26:00 +0800

jsoncons (1.3.0-2) unstable; urgency=medium

  * d/patches: add patch to disable flaky tests on some architectures

 -- Shengqi Chen <harry@debian.org>  Sat, 12 Apr 2025 23:33:56 +0800

jsoncons (1.3.0-1) unstable; urgency=medium

  * Initial packaging for jsoncons (closes: #1100410).

 -- Shengqi Chen <harry@debian.org>  Thu, 13 Mar 2025 23:21:40 +0800

## jsoncons 1.3.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

project(jsoncons CXX)

set(JSONCONS_PROJECT_DIR ${PROJECT_SOURCE_DIR})
set(JSONCONS_INCLUDE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/include)

# Versioning
# ==========

file(STRINGS "${JSONCONS_INCLUDE_DIR}/jsoncons/config/version.hpp" jsoncons_version_defines
     REGEX "#define JSONCONS_VERSION_(MAJOR|MINOR|PATCH)")
foreach(ver ${jsoncons_version_defines})
    if(ver MATCHES "#define JSONCONS_VERSION_(MAJOR|MINOR|PATCH) +([^ ]+)$")
        set(JSONCONS_VERSION_${CMAKE_MATCH_1} "${CMAKE_MATCH_2}" CACHE INTERNAL "")
    endif()
endforeach()
set(${PROJECT_NAME}_VERSION
    ${JSONCONS_VERSION_MAJOR}.${JSONCONS_VERSION_MINOR}.${JSONCONS_VERSION_PATCH})
message(STATUS "jsoncons v${${PROJECT_NAME}_VERSION}")

# Build
# =====

add_library(jsoncons INTERFACE)
target_include_directories(jsoncons INTERFACE $<BUILD_INTERFACE:${JSONCONS_INCLUDE_DIR}>
                                           $<INSTALL_INTERFACE:include>)

OPTION(JSONCONS_BUILD_TESTS "jsoncons test suite" ON)

if(JSONCONS_BUILD_TESTS)
    include(CTest)
    enable_testing()
    add_subdirectory(test)
endif()

# Installation
# ============

include(GNUInstallDirs)
include(CMakePackageConfigHelpers)

install(TARGETS jsoncons
        EXPORT ${PROJECT_NAME}-targets)

# Makes the project importable from the build directory
export(EXPORT ${PROJECT_NAME}-targets
       FILE "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}Targets.cmake")

install(DIRECTORY ${JSONCONS_INCLUDE_DIR}/jsoncons
                  ${JSONCONS_INCLUDE_DIR}/jsoncons_ext
        DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})

# GNUInstallDirs "DATADIR" wrong here; CMake search path wants "share".
set(JSONCONS_CMAKECONFIG_INSTALL_DIR "${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}" CACHE STRING "install path for jsonconsConfig.cmake")

configure_package_config_file(cmake/Config.cmake
                              "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}Config.cmake"
                              INSTALL_DESTINATION ${JSONCONS_CMAKECONFIG_INSTALL_DIR})

# jsoncons is header-only and does not depend on the architecture.

if (${CMAKE_VERSION} VERSION_LESS "3.14.0")
   write_basic_package_version_file(${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}ConfigVersion.cmake
                                    VERSION ${${PROJECT_NAME}_VERSION}
                                    COMPATIBILITY AnyNewerVersion)
else ()
   write_basic_package_version_file(${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}ConfigVersion.cmake
                                    VERSION ${${PROJECT_NAME}_VERSION}
                                    COMPATIBILITY AnyNewerVersion
                                    ARCH_INDEPENDENT)
endif ()

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}Config.cmake
              ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}ConfigVersion.cmake
        DESTINATION ${JSONCONS_CMAKECONFIG_INSTALL_DIR})
install(EXPORT ${PROJECT_NAME}-targets
        FILE ${PROJECT_NAME}Targets.cmake
        DESTINATION ${JSONCONS_CMAKECONFIG_INSTALL_DIR})

=== test/CMakeLists.txt ===
if (CMAKE_CURRENT_SOURCE_DIR STREQUAL CMAKE_SOURCE_DIR)
    project(jsoncons-test)

    find_package(jsoncons REQUIRED CONFIG)
    set(JSONCONS_INCLUDE_DIR ${jsoncons_INCLUDE_DIRS})
endif ()

if(NOT CMAKE_BUILD_TYPE)
message(STATUS "Forcing tests build type to Release")
set(CMAKE_BUILD_TYPE Release CACHE STRING "Choose the type of build." FORCE)
endif()

include(CheckCXXCompilerFlag)

string(TOUPPER "${CMAKE_BUILD_TYPE}" U_CMAKE_BUILD_TYPE)

OPTION(JSONCONS_SANITIZE "sanitize" OFF)
option(JSONCONS_VALGRIND "Execute tests with valgrind" OFF)

if(JSONCONS_VALGRIND)
    find_program(CMAKE_MEMORYCHECK_COMMAND valgrind)
    message(STATUS "Executing test suite with Valgrind (${CMAKE_MEMORYCHECK_COMMAND})")
    set(memcheck_command "${CMAKE_MEMORYCHECK_COMMAND} ${CMAKE_MEMORYCHECK_COMMAND_OPTIONS} --error-exitcode=1 --leak-check=full")
    separate_arguments(memcheck_command)
endif()
 
include (CTest)

# load per-platform configuration
# include (${JSONCONS_PROJECT_DIR}/cmake/${CMAKE_SYSTEM_NAME}.cmake)

# -fsanitize=undefined clang issue
if (JSONCONS_SANITIZE)
    if(NOT MSVC)
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -fsanitize=address -fno-omit-frame-pointer")
        message(STATUS "SANITIZE ON")
    endif()
endif()

if(MSVC)
    set(CMAKE_EXE_LINKER_FLAGS /MANIFEST:NO)
endif()

set(CTEST_OUTPUT_ON_FAILURE ON)

set(JSONCONS_TESTS_DIR ${JSONCONS_PROJECT_DIR}/test)
set(JSONCONS_INCLUDE_DIR ${JSONCONS_PROJECT_DIR}/include)
set(JSONCONS_THIRD_PARTY_INCLUDE_DIR ${JSONCONS_TESTS_DIR}/thirdparty)

set(CATCH_INCLUDE_DIR ${JSONCONS_THIRD_PARTY_INCLUDE_DIR}/catch)
add_library(catch INTERFACE)

if (${CMAKE_VERSION} VERSION_LESS "3.8.0")
    target_compile_features(catch INTERFACE cxx_range_for)  # for C++11 - flags
else()
    target_compile_features(catch INTERFACE cxx_std_11)
endif()

target_include_directories (catch INTERFACE ${CATCH_INCLUDE_DIR})

add_executable(unit_tests 
               fuzz_regression/src/fuzz_regression_tests.cpp
               bson/src/bson_cursor_tests.cpp
               bson/src/bson_encoder_tests.cpp
               bson/src/bson_reader_tests.cpp
               bson/src/bson_decimal128_tests.cpp
               bson/src/bson_oid_tests.cpp
               bson/src/bson_test_suite.cpp
               bson/src/encode_decode_bson_tests.cpp
               cbor/src/cbor_bitset_traits_tests.cpp
               cbor/src/cbor_cursor_tests.cpp
               cbor/src/cbor_event_reader_tests.cpp
               cbor/src/cbor_encoder_tests.cpp
               cbor/src/cbor_event_visitor_tests.cpp
               cbor/src/cbor_reader_tests.cpp
               cbor/src/cbor_tests.cpp
               cbor/src/cbor_typed_array_tests.cpp
               cbor/src/decode_cbor_tests.cpp
               cbor/src/encode_cbor_tests.cpp
               csv/src/csv_reader_tests.cpp
               csv/src/csv_cursor_tests.cpp
               csv/src/csv_subfield_tests.cpp
               csv/src/csv_tests.cpp
               csv/src/encode_decode_csv_tests.cpp
               jmespath/src/jmespath_custom_function_tests.cpp
               jmespath/src/jmespath_expression_tests.cpp
               jmespath/src/jmespath_let_tests.cpp
               jmespath/src/jmespath_tests.cpp
               mergepatch/src/mergepatch_test_suite.cpp
               jsonpatch/src/jsonpatch_test_suite.cpp
               jsonpatch/src/jsonpatch_tests.cpp
               jsonpath/src/jsonpath_flatten_tests.cpp
               jsonpath/src/jsonpath_function_tests.cpp
               jsonpath/src/path_node_tests.cpp
               jsonpath/src/json_location_tests.cpp
               jsonpath/src/json_location_parser_tests.cpp
               jsonpath/src/jsonpath_custom_function_tests.cpp
               jsonpath/src/jsonpath_json_query_tests.cpp
               jsonpath/src/jsonpath_expression_tests.cpp
               jsonpath/src/jsonpath_json_replace_tests.cpp
               jsonpath/src/jsonpath_select_paths_tests.cpp
               jsonpath/src/jsonpath_test_suite.cpp
               jsonpath/src/jsonpath_stateful_allocator_tests.cpp
               jsonpointer/src/jsonpointer_flatten_tests.cpp
               jsonpointer/src/jsonpointer_tests.cpp
               jsonschema/src/abort_early_tests.cpp
               jsonschema/src/custom_message_tests.cpp
               jsonschema/src/json_schema_walk_tests.cpp
               jsonschema/src/format_validator_tests.cpp
               jsonschema/src/validation_report_tests.cpp
               jsonschema/src/dynamic_ref_tests.cpp
               jsonschema/src/jsonschema_defaults_tests.cpp
               jsonschema/src/jsonschema_draft4_tests.cpp
               jsonschema/src/jsonschema_draft6_tests.cpp
               jsonschema/src/jsonschema_draft7_tests.cpp
               jsonschema/src/jsonschema_draft201909_tests.cpp
               jsonschema/src/jsonschema_draft202012_tests.cpp
               jsonschema/src/schema_version_tests.cpp
               msgpack/src/decode_msgpack_tests.cpp
               msgpack/src/encode_msgpack_tests.cpp
               msgpack/src/msgpack_bitset_traits_tests.cpp
               msgpack/src/msgpack_cursor_tests.cpp
               msgpack/src/msgpack_event_reader_tests.cpp
               msgpack/src/msgpack_encoder_tests.cpp
               msgpack/src/msgpack_tests.cpp
               msgpack/src/msgpack_timestamp_tests.cpp
               corelib/src/source_adaptor_tests.cpp
               corelib/src/value_converter_tests.cpp
               corelib/src/decode_traits_tests.cpp
               corelib/src/detail/optional_tests.cpp
               corelib/src/detail/span_tests.cpp
               corelib/src/detail/string_view_tests.cpp
               corelib/src/utility/byte_string_tests.cpp
               corelib/src/utility/heap_string_tests.cpp
               corelib/src/utility/bigint_tests.cpp
               corelib/src/utility/uri_tests.cpp
               corelib/src/utility/extension_traits_tests.cpp
               corelib/src/utility/unicode_conv_tests.cpp
               corelib/src/detail/to_integer_tests.cpp
               corelib/src/double_round_trip_tests.cpp
               corelib/src/double_to_string_tests.cpp
               corelib/src/dtoa_tests.cpp
               corelib/src/encode_decode_json_tests.cpp
               corelib/src/encode_traits_tests.cpp
               corelib/src/json_parser_recovery_tests.cpp
               corelib/src/json_array_tests.cpp
               corelib/src/json_as_tests.cpp
               corelib/src/json_bitset_traits_tests.cpp
               corelib/src/json_checker_tests.cpp
               corelib/src/json_compare_tests.cpp
               corelib/src/json_const_pointer_arg_tests.cpp
               corelib/src/json_pointer_arg_tests.cpp
               corelib/src/json_assignment_tests.cpp
               corelib/src/json_constructor_tests.cpp
               corelib/src/json_cursor_tests.cpp
               corelib/src/json_encoder_tests.cpp
               corelib/src/json_exception_tests.cpp
               corelib/src/json_filter_tests.cpp
               corelib/src/json_in_place_update_tests.cpp
               corelib/src/json_integer_tests.cpp
               corelib/src/json_less_tests.cpp
               corelib/src/json_line_split_tests.cpp
               corelib/src/json_literal_operator_tests.cpp
               corelib/src/json_object_tests.cpp
               corelib/src/ojson_object_tests.cpp
               corelib/src/json_options_tests.cpp
               corelib/src/json_parser_error_tests.cpp
               corelib/src/json_parser_position_tests.cpp
               corelib/src/json_parser_tests.cpp
               corelib/src/json_push_back_tests.cpp
               corelib/src/json_reader_exception_tests.cpp
               corelib/src/json_reader_tests.cpp
               corelib/src/json_storage_tests.cpp
               corelib/src/json_swap_tests.cpp
               corelib/src/json_traits_macro_functional_tests.cpp
               corelib/src/json_traits_macro_tests.cpp
               corelib/src/json_traits_macro_limit_tests.cpp
               corelib/src/json_traits_name_macro_tests.cpp
               corelib/src/json_type_traits_chrono_tests.cpp
               corelib/src/json_type_traits_container_tests.cpp
               corelib/src/json_type_traits_tests.cpp
               corelib/src/json_validation_tests.cpp 
               corelib/src/jsoncons_tests.cpp
               corelib/src/JSONTestSuite_tests.cpp
               corelib/src/ojson_tests.cpp
               corelib/src/parse_string_tests.cpp
               corelib/src/short_string_tests.cpp
               corelib/src/source_tests.cpp
               corelib/src/staj_iterator_tests.cpp
               corelib/src/polymorphic_allocator_tests.cpp
               corelib/src/scoped_allocator_adaptor_tests.cpp
               corelib/src/string_to_double_tests.cpp
               corelib/src/wjson_tests.cpp
               ubjson/src/decode_ubjson_tests.cpp
               ubjson/src/encode_ubjson_tests.cpp
               ubjson/src/ubjson_cursor_tests.cpp
               ubjson/src/ubjson_encoder_tests.cpp
               corelib/src/testmain.cpp
)              

if (${CMAKE_VERSION} VERSION_LESS "3.8.0")
    target_compile_features(unit_tests INTERFACE cxx_range_for)  # for C++11 - flags
else()
    target_compile_features(unit_tests INTERFACE cxx_std_11)
endif()

target_compile_options(unit_tests PRIVATE
    $<$<CXX_COMPILER_ID:MSVC>: /EHsc /MP /bigobj /W4>
)

if (CMAKE_CXX_COMPILER_ID STREQUAL "GNU" AND CMAKE_CXX_COMPILER_VERSION VERSION_GREATER_EQUAL "8.0")
    message(STATUS Version " ${CMAKE_CXX_COMPILER_VERSION}")
    # older GCC versions don't support 
   target_compile_options(unit_tests PRIVATE
       $<$<CXX_COMPILER_ID:GNU>:-Werror=maybe-uninitialized -Wnon-virtual-dtor -Werror=stringop-overflow -Werror -Wall -Wextra -Wcast-align -Wcast-qual -Wimplicit-fallthrough -Wsign-compare -pedantic -Wnonnull -Wnull-dereference -Werror=nonnull>
   )
endif()

if (NOT CMAKE_SYSTEM_NAME STREQUAL Windows)
target_compile_options(unit_tests PRIVATE
    $<$<CXX_COMPILER_ID:Clang>:-Werror=uninitialized -Werror -Wall -Wextra -Wimplicit-fallthrough -Wcast-align -Wcast-qual -Wsign-compare -pedantic>
)
endif()

add_test(NAME unit_tests COMMAND unit_tests WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}/test)

target_include_directories (unit_tests 
                            PUBLIC ${JSONCONS_INCLUDE_DIR} 
                            PRIVATE ${JSONCONS_TESTS_DIR}
                            PRIVATE ${JSONCONS_THIRD_PARTY_INCLUDE_DIR})

target_link_libraries(unit_tests catch)

=== examples/build/cmake/CMakeLists.txt ===

#
# jsoncons examples CMake file
#

cmake_minimum_required (VERSION 2.8)

# load global config
include (../../build/cmake/Config.cmake)


project (Examples CXX)

# load per-platform configuration
include (../../build/cmake/${CMAKE_SYSTEM_NAME}.cmake)

include_directories (../../include
                     ../../../include)

file(GLOB_RECURSE Example_sources ../../src/*.cpp)

# Loop through each example file and create an executable for each
foreach(example_file ${Example_sources})
    # Extract the filename without path and extension
    get_filename_component(example_name ${example_file} NAME_WE)

    # Create an executable with the example name and file
    add_executable(${example_name} ${example_file})

    if (${CMAKE_SYSTEM_NAME} STREQUAL "Linux" AND ${CMAKE_CXX_COMPILER_ID} STREQUAL "Clang")
      # special link option on Linux because llvm stl rely on GNU stl
      target_link_libraries(${example_name} -Wl,-lstdc++)
    endif()
endforeach()

=== debian/changelog ===
jsoncons (1.3.2-1) unstable; urgency=medium

  * New upstream version 1.3.2.

 -- Shengqi Chen <harry@debian.org>  Fri, 02 May 2025 16:16:15 +0800

=== debian/watch ===
version=4
https://github.com/danielaparker/jsoncons/tags .*/v?(\d.*)@ARCHIVE_EXT@

## jsoncons 1.4.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 3.5)
+cmake_minimum_required(VERSION 3.15)
 
 project(jsoncons CXX)
 
@@ -45,14 +45,14 @@
 
 # Makes the project importable from the build directory
 export(EXPORT ${PROJECT_NAME}-targets
+       NAMESPACE jsoncons::
        FILE "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}Targets.cmake")
 
 install(DIRECTORY ${JSONCONS_INCLUDE_DIR}/jsoncons
                   ${JSONCONS_INCLUDE_DIR}/jsoncons_ext
         DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})
 
-# GNUInstallDirs "DATADIR" wrong here; CMake search path wants "share".
-set(JSONCONS_CMAKECONFIG_INSTALL_DIR "${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}" CACHE STRING "install path for jsonconsConfig.cmake")
+set(JSONCONS_CMAKECONFIG_INSTALL_DIR "${CMAKE_INSTALL_DATADIR}/cmake/${PROJECT_NAME}" CACHE STRING "install path for jsonconsConfig.cmake")
 
 configure_package_config_file(cmake/Config.cmake
                               "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}Config.cmake"
@@ -60,7 +60,7 @@
 
 # jsoncons is header-only and does not depend on the architecture.
 
-if (${CMAKE_VERSION} VERSION_LESS "3.14.0")
+if (CMAKE_VERSION VERSION_LESS "3.14.0")
    write_basic_package_version_file(${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}ConfigVersion.cmake
                                     VERSION ${${PROJECT_NAME}_VERSION}
                                     COMPATIBILITY AnyNewerVersion)
@@ -76,5 +76,6 @@
         DESTINATION ${JSONCONS_CMAKECONFIG_INSTALL_DIR})
 install(EXPORT ${PROJECT_NAME}-targets
         FILE ${PROJECT_NAME}Targets.cmake
+        NAMESPACE jsoncons::
         DESTINATION ${JSONCONS_CMAKECONFIG_INSTALL_DIR})

=== debian/changelog ===
jsoncons (1.4.0-1) unstable; urgency=medium

  * d/watch: switch to uscan version 5.
  * New upstream version 1.4.0.
  * d/patches: disable -Werror=maybe-uninitialized in tests (closes: #1114156).
  * d/libjsoncons-dev.install: change cmake config install location to
    /usr/share/cmake.

 -- Shengqi Chen <harry@debian.org>  Fri, 12 Sep 2025 21:38:49 +0800

=== debian/control ===
Source: jsoncons
Section: utils
Priority: optional
Standards-Version: 4.7.2
Maintainer: Shengqi Chen <harry@debian.org>
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 ninja-build
Homepage: https://danielaparker.github.io/jsoncons/
Vcs-Git: https://salsa.debian.org/harry/jsoncons.git
Vcs-Browser: https://salsa.debian.org/harry/jsoncons
Rules-Requires-Root: no

Package: libjsoncons-dev
Section: libdevel
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: C++ header-only library for JSON and alike formats (development files)
 jsoncons is a C++, header-only library for constructing JSON and JSON-like data
 formats, including JSON Pointer, JSON Patch, JSON Schema, JSONPath, JMESPath,
 CSV, MessagePack, CBOR, BSON, UBJSON.
 .
 This package contains the development files.

Package: libjsoncons-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: C++ header-only library for JSON and alike formats (documentation)
 jsoncons is a C++, header-only library for constructing JSON and JSON-like data
 formats, including JSON Pointer, JSON Patch, JSON Schema, JSONPath, JMESPath,
 CSV, MessagePack, CBOR, BSON, UBJSON.
 .
 This package contains the documentation and examples of libjsoncons.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --buildsystem=cmake+ninja

# this package is not arch-depent, so no need for host triple
override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_INSTALL_LIBDIR=/usr/lib

=== debian/watch ===
Version: 5
Template: GitHub
Owner: danielaparker
Project: jsoncons

## jsoncons 1.4.3

=== test/CMakeLists.txt ===
if (CMAKE_CURRENT_SOURCE_DIR STREQUAL CMAKE_SOURCE_DIR)
    project(jsoncons-test)

    find_package(jsoncons REQUIRED CONFIG)
    set(JSONCONS_INCLUDE_DIR ${jsoncons_INCLUDE_DIRS})
endif ()

if(NOT CMAKE_BUILD_TYPE)
message(STATUS "Forcing tests build type to Release")
set(CMAKE_BUILD_TYPE Release CACHE STRING "Choose the type of build." FORCE)
endif()

include(CheckCXXCompilerFlag)

string(TOUPPER "${CMAKE_BUILD_TYPE}" U_CMAKE_BUILD_TYPE)

OPTION(JSONCONS_SANITIZE "sanitize" OFF)
option(JSONCONS_VALGRIND "Execute tests with valgrind" OFF)

if(JSONCONS_VALGRIND)
    find_program(CMAKE_MEMORYCHECK_COMMAND valgrind)
    message(STATUS "Executing test suite with Valgrind (${CMAKE_MEMORYCHECK_COMMAND})")
    set(memcheck_command "${CMAKE_MEMORYCHECK_COMMAND} ${CMAKE_MEMORYCHECK_COMMAND_OPTIONS} --error-exitcode=1 --leak-check=full")
    separate_arguments(memcheck_command)
endif()
 
include (CTest)

# load per-platform configuration
# include (${JSONCONS_PROJECT_DIR}/cmake/${CMAKE_SYSTEM_NAME}.cmake)

# -fsanitize=undefined clang issue
if (JSONCONS_SANITIZE)
    if(NOT MSVC)
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -fsanitize=address -fno-omit-frame-pointer")
        message(STATUS "SANITIZE ON")
    endif()
endif()

if(MSVC)
    set(CMAKE_EXE_LINKER_FLAGS /MANIFEST:NO)
endif()

set(CTEST_OUTPUT_ON_FAILURE ON)

set(JSONCONS_TESTS_DIR ${JSONCONS_PROJECT_DIR}/test)
set(JSONCONS_INCLUDE_DIR ${JSONCONS_PROJECT_DIR}/include)
set(JSONCONS_THIRD_PARTY_INCLUDE_DIR ${JSONCONS_TESTS_DIR}/thirdparty)

set(CATCH_INCLUDE_DIR ${JSONCONS_THIRD_PARTY_INCLUDE_DIR}/catch)
add_library(catch INTERFACE)

if (CMAKE_VERSION VERSION_LESS "3.8.0")
    target_compile_features(catch INTERFACE cxx_range_for)  # for C++11 - flags
else()
    target_compile_features(catch INTERFACE cxx_std_11)
endif()

target_include_directories (catch INTERFACE ${CATCH_INCLUDE_DIR})

add_executable(unit_tests 
               bson/src/bson_cursor_tests.cpp
               bson/src/bson_decimal128_tests.cpp
               bson/src/bson_encoder_tests.cpp
               bson/src/bson_oid_tests.cpp
               bson/src/bson_reader_tests.cpp
               bson/src/bson_test_suite.cpp
               bson/src/encode_decode_bson_tests.cpp
               cbor/src/cbor_bitset_traits_tests.cpp
               cbor/src/cbor_cursor_tests.cpp
               cbor/src/cbor_encoder_tests.cpp
               cbor/src/cbor_event_reader_tests.cpp
               cbor/src/cbor_event_visitor_tests.cpp
               cbor/src/cbor_reader_tests.cpp
               cbor/src/cbor_tests.cpp
               cbor/src/cbor_typed_array_tests.cpp
               cbor/src/decode_cbor_tests.cpp
               cbor/src/encode_cbor_tests.cpp
               corelib/src/detail/optional_tests.cpp
               corelib/src/detail/span_tests.cpp
               corelib/src/detail/string_view_tests.cpp
               corelib/src/double_round_trip_tests.cpp
               corelib/src/double_to_string_tests.cpp
               corelib/src/dtoa_tests.cpp
               corelib/src/decode_json_using_allocator_tests.cpp
               corelib/src/encode_decode_json_tests.cpp
               corelib/src/json_array_tests.cpp
               corelib/src/json_as_tests.cpp
               corelib/src/json_assignment_tests.cpp
               corelib/src/json_bitset_traits_tests.cpp
               corelib/src/json_checker_tests.cpp
               corelib/src/json_compare_tests.cpp
               corelib/src/json_const_pointer_arg_tests.cpp
               corelib/src/json_constructor_tests.cpp
               corelib/src/json_cursor_tests.cpp
               corelib/src/json_encoder_tests.cpp
               corelib/src/json_exception_tests.cpp
               corelib/src/json_filter_tests.cpp
               corelib/src/json_in_place_update_tests.cpp
               corelib/src/json_integer_tests.cpp
               corelib/src/json_less_tests.cpp
               corelib/src/json_line_split_tests.cpp
               corelib/src/json_literal_operator_tests.cpp
               corelib/src/json_object_tests.cpp
               corelib/src/json_options_tests.cpp
               corelib/src/json_parser_error_tests.cpp
               corelib/src/json_parser_position_tests.cpp
               corelib/src/json_parser_recovery_tests.cpp
               corelib/src/json_parser_tests.cpp
               corelib/src/json_pointer_arg_tests.cpp
               corelib/src/json_push_back_tests.cpp
               corelib/src/json_reader_exception_tests.cpp
               corelib/src/json_reader_tests.cpp
               corelib/src/json_storage_tests.cpp
               corelib/src/json_swap_tests.cpp
               corelib/src/json_uses_allocator_tests.cpp
               corelib/src/jsoncons_tests.cpp
               corelib/src/JSONTestSuite_tests.cpp
               corelib/src/legacy_json_type_traits_tests.cpp
               corelib/src/ojson_object_tests.cpp
               corelib/src/ojson_tests.cpp
               corelib/src/parse_string_tests.cpp
               corelib/src/polymorphic_allocator_tests.cpp
               corelib/src/reflect/decode_traits_tests.cpp
               corelib/src/reflect/encode_traits_tests.cpp
               corelib/src/reflect/json_conv_traits_chrono_tests.cpp
               corelib/src/reflect/json_conv_traits_string_tests.cpp
               corelib/src/reflect/json_conv_traits_tests.cpp
               corelib/src/reflect/json_conv_traits_using_allocator_tests.cpp
               corelib/src/reflect/reflect_traits_container_tests.cpp
               corelib/src/reflect/reflect_traits_gen_functional_tests.cpp
               corelib/src/reflect/reflect_traits_gen_limit_tests.cpp
               corelib/src/reflect/reflect_traits_gen_tests.cpp
               corelib/src/reflect/reflect_traits_gen_using_allocator_tests.cpp
               corelib/src/reflect/reflect_traits_name_gen_tests.cpp
               corelib/src/scoped_allocator_adaptor_tests.cpp
               corelib/src/short_string_tests.cpp
               corelib/src/source_adaptor_tests.cpp
               corelib/src/source_tests.cpp
               corelib/src/staj_array_iterator_ec_tests.cpp 
               corelib/src/staj_iterator_tests.cpp
               corelib/src/string_to_double_tests.cpp
               corelib/src/try_decode_json_tests.cpp
               corelib/src/try_to_json_tests.cpp
               corelib/src/utility/bigint_tests.cpp
               corelib/src/utility/byte_string_tests.cpp
               corelib/src/utility/conversion_tests.cpp
               corelib/src/utility/extension_traits_tests.cpp
               corelib/src/utility/heap_string_tests.cpp
               corelib/src/utility/read_number_tests.cpp
               corelib/src/utility/unicode_conv_tests.cpp
               corelib/src/utility/uri_tests.cpp
               corelib/src/wjson_tests.cpp
               csv/src/csv_cursor_tests.cpp
               csv/src/csv_reader_tests.cpp
               csv/src/csv_subfield_tests.cpp
               csv/src/csv_tests.cpp
               csv/src/encode_decode_csv_tests.cpp
               fuzz_regression/src/fuzz_regression_tests.cpp
               jmespath/src/jmespath_custom_function_tests.cpp
               jmespath/src/jmespath_expression_tests.cpp
               jmespath/src/jmespath_let_tests.cpp
               jmespath/src/jmespath_tests.cpp
               jsonpatch/src/jsonpatch_test_suite.cpp
               jsonpatch/src/jsonpatch_tests.cpp
               jsonpath/src/json_location_parser_tests.cpp
               jsonpath/src/json_location_tests.cpp
               jsonpath/src/jsonpath_custom_function_tests.cpp
               jsonpath/src/jsonpath_expression_tests.cpp
               jsonpath/src/jsonpath_flatten_tests.cpp
               jsonpath/src/jsonpath_function_tests.cpp
               jsonpath/src/jsonpath_json_query_tests.cpp
               jsonpath/src/jsonpath_json_replace_tests.cpp
               jsonpath/src/jsonpath_select_paths_tests.cpp
               jsonpath/src/jsonpath_stateful_allocator_tests.cpp
               jsonpath/src/jsonpath_test_suite.cpp
               jsonpath/src/path_node_tests.cpp
               jsonpointer/src/jsonpointer_flatten_tests.cpp
               jsonpointer/src/jsonpointer_tests.cpp
               jsonschema/src/abort_early_tests.cpp
               jsonschema/src/custom_message_tests.cpp
               jsonschema/src/dynamic_ref_tests.cpp
               jsonschema/src/format_validator_tests.cpp
               jsonschema/src/json_schema_walk_tests.cpp
               jsonschema/src/jsonschema_defaults_tests.cpp
               jsonschema/src/jsonschema_draft201909_tests.cpp
               jsonschema/src/jsonschema_draft202012_tests.cpp
               jsonschema/src/jsonschema_draft4_tests.cpp
               jsonschema/src/jsonschema_draft6_tests.cpp
               jsonschema/src/jsonschema_draft7_tests.cpp
               jsonschema/src/jsonschema_keyword_tests.cpp
               jsonschema/src/schema_version_tests.cpp
               jsonschema/src/validation_report_tests.cpp
               mergepatch/src/mergepatch_test_suite.cpp
               msgpack/src/decode_msgpack_tests.cpp
               msgpack/src/encode_msgpack_tests.cpp
               msgpack/src/msgpack_bitset_traits_tests.cpp
               msgpack/src/msgpack_cursor_tests.cpp
               msgpack/src/msgpack_encoder_tests.cpp
               msgpack/src/msgpack_event_reader_tests.cpp
               msgpack/src/msgpack_tests.cpp
               msgpack/src/msgpack_timestamp_tests.cpp
               ubjson/src/decode_ubjson_tests.cpp
               ubjson/src/encode_ubjson_tests.cpp
               ubjson/src/ubjson_cursor_tests.cpp
               ubjson/src/ubjson_encoder_tests.cpp
               corelib/src/testmain.cpp
)              

if (CMAKE_VERSION VERSION_LESS "3.8.0")
    target_compile_features(unit_tests INTERFACE cxx_range_for)  # for C++11 - flags
else()
    target_compile_features(unit_tests INTERFACE cxx_std_11)
endif()

target_compile_options(unit_tests PRIVATE
    $<$<CXX_COMPILER_ID:MSVC>: /EHsc /MP /bigobj /W4>
)

if (CMAKE_CXX_COMPILER_ID STREQUAL "GNU" AND CMAKE_CXX_COMPILER_VERSION VERSION_GREATER_EQUAL "8.0")
    message(STATUS Version " ${CMAKE_CXX_COMPILER_VERSION}")
    # older GCC versions don't support 
   target_compile_options(unit_tests PRIVATE
       $<$<CXX_COMPILER_ID:GNU>:-Werror=maybe-uninitialized -Wnon-virtual-dtor -Werror=stringop-overflow -Werror -Wall -Wextra -Wcast-align -Wcast-qual -Wimplicit-fallthrough -Wsign-compare -pedantic -Wnonnull -Wnull-dereference -Werror=nonnull>
   )
endif()

if (NOT CMAKE_SYSTEM_NAME STREQUAL Windows)
target_compile_options(unit_tests PRIVATE
    $<$<CXX_COMPILER_ID:Clang>:-Werror=uninitialized -Werror -Wall -Wextra -Wimplicit-fallthrough -Wcast-align -Wcast-qual -Wsign-compare -pedantic>
)
endif()

add_test(NAME unit_tests COMMAND unit_tests WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}/test)

target_include_directories (unit_tests 
                            PUBLIC ${JSONCONS_INCLUDE_DIR} 
                            PRIVATE ${JSONCONS_TESTS_DIR}
                            PRIVATE ${JSONCONS_THIRD_PARTY_INCLUDE_DIR})

target_link_libraries(unit_tests catch)

=== debian/changelog ===
jsoncons (1.4.3-2) unstable; urgency=medium

  * d/rules: fix false positive of GCC and permission issue in source.
  * d/control: do not build libjsoncons-doc with nodoc profile.

 -- Shengqi Chen <harry@debian.org>  Wed, 19 Nov 2025 16:44:21 +0800

jsoncons (1.4.3-1) unstable; urgency=medium

  * New upstream version 1.4.3.
  * d/patches: remove workaround for compiler warnings.

 -- Shengqi Chen <harry@debian.org>  Thu, 23 Oct 2025 16:59:46 +0800

=== debian/control ===
--- 
+++ 
@@ -28,6 +28,7 @@
 Section: doc
 Architecture: all
 Multi-Arch: foreign
+Build-Profiles: <!nodoc>
 Depends: ${misc:Depends}
 Description: C++ header-only library for JSON and alike formats (documentation)
  jsoncons is a C++, header-only library for constructing JSON and JSON-like data

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
# https://github.com/danielaparker/jsoncons/issues/645
export DEB_CXXFLAGS_MAINT_APPEND = -Wno-error=free-nonheap-object

%:
	dh $@ --buildsystem=cmake+ninja

# this package is not arch-depent, so no need for host triple
override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_INSTALL_LIBDIR=/usr/lib

execute_before_dh_install:
	# https://github.com/danielaparker/jsoncons/issues/657
	chmod a-x examples/build/cmake/CMakeLists.txt

## jsoncons 1.5.0

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -31,12 +31,14 @@
 
 # -fsanitize=undefined clang issue
 if (JSONCONS_SANITIZE)
-    if(NOT MSVC)
+    if (${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
+        set(CMAKE_XCODE_SCHEME_ADDRESS_SANITIZER ON)
+        message(STATUS "MACOS SANITIZE ON")
+    elseif(NOT MSVC)
         set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -fsanitize=address -fno-omit-frame-pointer")
-        message(STATUS "SANITIZE ON")
+        message(STATUS "NOT MSVC SANITIZE ON")
     endif()
 endif()
-
 if(MSVC)
     set(CMAKE_EXE_LINKER_FLAGS /MANIFEST:NO)
 endif()
@@ -221,7 +223,7 @@
     message(STATUS Version " ${CMAKE_CXX_COMPILER_VERSION}")
     # older GCC versions don't support 
    target_compile_options(unit_tests PRIVATE
-       $<$<CXX_COMPILER_ID:GNU>:-Werror=maybe-uninitialized -Wnon-virtual-dtor -Werror=stringop-overflow -Werror -Wall -Wextra -Wcast-align -Wcast-qual -Wimplicit-fallthrough -Wsign-compare -pedantic -Wnonnull -Wnull-dereference -Werror=nonnull>
+       $<$<CXX_COMPILER_ID:GNU>:-Werror=maybe-uninitialized -Wnon-virtual-dtor -Werror=free-nonheap-object -Werror=stringop-overflow -Werror -Wall -Wextra -Wcast-align -Wcast-qual -Wimplicit-fallthrough -Wsign-compare -pedantic -Wnonnull -Wnull-dereference -Werror=nonnull>
    )
 endif()

=== examples/build/cmake/CMakeLists.txt ===
--- 
+++ 
@@ -1,13 +1,11 @@
-
 #
 # jsoncons examples CMake file
 #
 
-cmake_minimum_required (VERSION 2.8)
+cmake_minimum_required(VERSION 3.5...3.14)
 
 # load global config
 include (../../build/cmake/Config.cmake)
-
 
 project (Examples CXX)
 
@@ -16,7 +14,7 @@
 
 include_directories (../../include
                      ../../../include)
-
+ 
 file(GLOB_RECURSE Example_sources ../../src/*.cpp)
 
 # Loop through each example file and create an executable for each
@@ -27,7 +25,7 @@
     # Create an executable with the example name and file
     add_executable(${example_name} ${example_file})
 
-    if (${CMAKE_SYSTEM_NAME} STREQUAL "Linux" AND ${CMAKE_CXX_COMPILER_ID} STREQUAL "Clang")
+    if ((CMAKE_SYSTEM_NAME STREQUAL "Linux") AND (CMAKE_CXX_COMPILER_ID STREQUAL "Clang"))
       # special link option on Linux because llvm stl rely on GNU stl
       target_link_libraries(${example_name} -Wl,-lstdc++)
     endif()

=== debian/changelog ===
jsoncons (1.5.0-2) unstable; urgency=medium

   * Add patch to fix autopkgtests on non-amd64 architectures.

 -- Shengqi Chen <harry@debian.org>  Mon, 22 Dec 2025 13:22:00 +0800

jsoncons (1.5.0-1) unstable; urgency=medium

  * New upstream version 1.5.0.

 -- Shengqi Chen <harry@debian.org>  Wed, 10 Dec 2025 13:52:54 +0800
